//
//  PlayingGameVM.swift
//  DouShouQi_App
//
//  Created by Rémi REGNAULT on 21/06/2024.
//

import Foundation
import DouShouQiModel

class PlayingGameVM: ObservableObject {
    
    // Properties
    @Published var game: Game
    
    // Computed properties
    public var currentPlayerName: String { game.players[game.rules.getNextPlayer()]?.name ?? (game.rules.getNextPlayer() == .player1 ? "P1" : "P2") }
    
    public var lastMove: String {
        if let move: Move = game.rules.historic.last {
            return "\(move.rowDestination).\(move.columnDestination)"
        }
        else {
            return ""
        }
    }
    
    public var lastPieceMoved: String { "oui" }
    
    // Inits
    init(withGame game: Game) {
        self.game = game
    }
    
    init?(withRules rules: Rules, andPlayer1 p1: DouShouQiModel.Player, andPlayer2 p2: DouShouQiModel.Player) {
        do {
            self.game = try Game(withRules: rules, andPlayer1: p1, andPlayer2: p2)
        } catch {
            print("Error")
            return nil
        }
    }
    
}
